/* Listing2314.java */

import java.util.concurrent.LinkedBlockingQueue;

class Producer2314 extends Thread
{
  private final LinkedBlockingQueue<String> v;

  public Producer2314(LinkedBlockingQueue<String> v)
  {
    this.v = v;
  }

  public void run()
  {
    String s;

    while (true) {
      s = "Wert " + Math.random();
      v.add(s);
      System.out.println("Produzent erzeugte " + s);
      try {
        Thread.sleep((int) (100 * Math.random()));
      }
      catch (InterruptedException x) {
        // nichts
      }
    }
  }
}

class Consumer2314 extends Thread
{
  private final LinkedBlockingQueue<String> v;

  public Consumer2314(LinkedBlockingQueue<String> v)
  {
    this.v = v;
  }

  public void run()
  {
    while (true) {
      try {
        String s = v.take();
        System.out.print(" Konsument fand " + s);
        System.out.println(" (verbleiben: " + v.size() + ")");
        Thread.sleep((int) (100 * Math.random()));
      }
      catch (InterruptedException e) {
        // nichts
      }
    }
  }
}

public class Listing2314
{
  public static void main(String[] args)
  {
    LinkedBlockingQueue<String> v = 
      new LinkedBlockingQueue<String>();

    Producer2314 p = new Producer2314(v);
    Consumer2314 c = new Consumer2314(v);
    p.start();
    c.start();
  }
}