/* Listing4716.java */

import javax.persistence.*;

public class Listing4716
{
  public static void main(String[] args)
  {
    //Erzeugen einer EntityManagerFactory mit Hilfe des symbolischen
    //Namens aus dem Persistenz Descriptor (persistence.xml)
    EntityManagerFactory emf =
      Persistence.createEntityManagerFactory("persistenceExample");

    //Erzeugen eines EntityManagers fr den Zugriff auf
    //die Datenbank
    EntityManager manager = emf.createEntityManager();

    //Beginn einer neuen Transanktion
    EntityTransaction tx = manager.getTransaction();
    tx.begin();

    //Erzeugen und Verknpfen der Java-Objekte
    Verzeichnis dir = new Verzeichnis("temp");

    Datei fileTest = new Datei("test.txt");
    dir.getFiles().add(fileTest);
    fileTest.setDirectory(dir);

    Datei fileInfo = new Datei("info.txt");
    dir.getFiles().add(fileInfo);
    fileInfo.setDirectory(dir);

    //Speichern des Verzeichnisses und der anhngenden Objekte
    manager.persist(dir);

    //Abschluss der Transaktion mit einem Commit
    tx.commit();

    //Freigabe der Ressourcen des EntityManagers
    manager.close();

    //Schlieen der EntityManagerFactory und Freigeben der
    //belegten Ressourcen
    emf.close();
  }
}